//------------------------------------------------------
// module  : BISDA.cc
// author  : Mignotte Max
// date    : 
// version : 1.0
// language: C++
// note    :
//------------------------------------------------------
//  

//------------------------------------------------
// INCLDED FILES ---------------------------------
//------------------------------------------------
#include "BISDA.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define NAME_IMG      "Image"
#define EXTENSION     "NoN"

//------------------------------------------------
// CONSTANTES ------------------------------------
//------------------------------------------------
const int   NBDEF=10; 
const float PARM=0.0;

const int DEFVISU=0;
const int TYPDEF=0;

const int ZOOM=1;
const int QUIT=0;
const int SAVE=0;
const int VISU=0;

//------------------------------------------------
// VARIABLES GLOBALES ----------------------------
//------------------------------------------------
char Name_img[NCHAR];
char Extension[NCHAR];

int NbDef;
float ParM;
int DefVisu;
int TypDef;

int   zoom;
int   flag_save;
int   flag_quit;
int   flag_visu;

//-------------------------
//--- Windows -------------
//-------------------------
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/cursorfont.h>

Display   *display;
int	  screen_num;
int 	  depth;
Window	  root;
Visual*	  visual;
GC	  gc;

/************************************************************************/
/* OPEN_DISPLAY()							*/
/************************************************************************/
int open_display()
{
  if ((display=XOpenDisplay(NULL))==NULL)
   { printf("Connection impossible\n");
     return(-1); }

  else
   { screen_num=DefaultScreen(display);
     visual=DefaultVisual(display,screen_num);
     depth=DefaultDepth(display,screen_num);
     root=RootWindow(display,screen_num);
     return 0; }
}

/************************************************************************/
/* FABRIQUE_WINDOW()							*/
/* Cette fonction cre une fenetre X et l'affiche  l'cran.	        */
/************************************************************************/
Window fabrique_window(char *nom_fen,int x,int y,int width,int height,int zoom)
{
  Window                 win;
  XSizeHints      size_hints;
  XWMHints          wm_hints;
  XClassHint     class_hints;
  XTextProperty  windowName, iconName;

  char *name=nom_fen;

  if(zoom<0) { width/=-zoom; height/=-zoom; }
  if(zoom>0) { width*=zoom;  height*=zoom;  }

  win=XCreateSimpleWindow(display,root,x,y,width,height,1,0,255);

  size_hints.flags=PPosition|PSize|PMinSize;
  size_hints.min_width=width;
  size_hints.min_height=height;

  XStringListToTextProperty(&name,1,&windowName);
  XStringListToTextProperty(&name,1,&iconName);
  wm_hints.initial_state=NormalState;
  wm_hints.input=True;
  wm_hints.flags=StateHint|InputHint;
  class_hints.res_name=nom_fen;
  class_hints.res_class=nom_fen;

  XSetWMProperties(display,win,&windowName,&iconName,
                   NULL,0,&size_hints,&wm_hints,&class_hints);

  gc=XCreateGC(display,win,0,NULL);

  XSelectInput(display,win,ExposureMask|KeyPressMask|ButtonPressMask| 
               ButtonReleaseMask|ButtonMotionMask|PointerMotionHintMask| 
               StructureNotifyMask);

  XMapWindow(display,win);
  return(win);
}

/****************************************************************************/
/* CREE_XIMAGE()							    */
/* Cre une XImage  partir d'un tableau de float                           */
/* L'image peut subir un zoom.						    */
/****************************************************************************/
XImage* cree_Ximage(float** mat,int z,int length,int width)
{
  int lgth,wdth,lig,col,zoom_col,zoom_lig;
  float somme;
  unsigned char	 pix;
  unsigned char* dat;
  XImage* imageX;

  /*Zoom positiv*/
  /*------------*/
  if (z>0)
  {
   lgth=length*z;
   wdth=width*z;

   dat=(unsigned char*)malloc(lgth*(wdth*4)*sizeof(unsigned char));
   if (dat==NULL)
      { printf("Impossible d'allouer de la memoire.");
        exit(-1); }

  for(lig=0;lig<lgth;lig=lig+z) for(col=0;col<wdth;col=col+z)
   { 
    pix=(unsigned char)mat[lig/z][col/z];
    for(zoom_lig=0;zoom_lig<z;zoom_lig++) for(zoom_col=0;zoom_col<z;zoom_col++)
      { 
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+0)]=pix;
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+1)]=pix;
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+2)]=pix;
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+3)]=pix; 
       }
    }
  } /*--------------------------------------------------------*/

  /*Zoom negatifv*/
  /*------------*/
  else
  {
   z=-z;
   lgth=(length/z);
   wdth=(width/z);

   dat=(unsigned char*)malloc(lgth*(wdth*4)*sizeof(unsigned char));
   if (dat==NULL)
      { printf("Impossible d'allouer de la memoire.");
        exit(-1); }

  for(lig=0;lig<(lgth*z);lig=lig+z) for(col=0;col<(wdth*z);col=col+z)
   {  
    somme=0.0;
    for(zoom_lig=0;zoom_lig<z;zoom_lig++) for(zoom_col=0;zoom_col<z;zoom_col++)
     somme+=mat[lig+zoom_lig][col+zoom_col];
           
     somme/=(z*z);    
     dat[((lig/z)*wdth*4)+((4*(col/z))+0)]=(unsigned char)somme;
     dat[((lig/z)*wdth*4)+((4*(col/z))+1)]=(unsigned char)somme;
     dat[((lig/z)*wdth*4)+((4*(col/z))+2)]=(unsigned char)somme;
     dat[((lig/z)*wdth*4)+((4*(col/z))+3)]=(unsigned char)somme; 
   }
  } /*--------------------------------------------------------*/

  imageX=XCreateImage(display,visual,depth,ZPixmap,0,(char*)dat,wdth,lgth,16,wdth*4);
  return (imageX);
}

/****************************************************************************/
/* CREE_XIMAGECOUL()							    */
/* Cre une XImage  partir d'un tableau 3 d de float                       */
/* L'image peut subir un zoom.						    */
/****************************************************************************/
XImage* cree_XimageCoul(float*** matRVB,int z,int length,int width)
{
  int i;
  int lgth,wdth,lig,col,zoom_col,zoom_lig;
  float somme;
  float sum[3];
  unsigned char	 pixR,pixV,pixB,pixN;
  unsigned char* dat;
  XImage* imageX;

  /*Zoom positif*/
  /*------------*/
  if (z>0)
  {
   lgth=length*z;
   wdth=width*z;

   dat=(unsigned char*)malloc(lgth*(wdth*4)*sizeof(unsigned char));
   if (dat==NULL)
      { printf("Impossible d'allouer de la memoire.");
        exit(-1); }

  for(lig=0;lig<lgth;lig=lig+z) for(col=0;col<wdth;col=col+z)
   { 
    pixR=(unsigned char)matRVB[0][lig/z][col/z];
    pixV=(unsigned char)matRVB[1][lig/z][col/z];
    pixB=(unsigned char)matRVB[2][lig/z][col/z];
    somme=(1.0/3.0)*(pixR+pixV+pixB);
    pixN=(unsigned char)somme;

    for(zoom_lig=0;zoom_lig<z;zoom_lig++) for(zoom_col=0;zoom_col<z;zoom_col++)
      { 
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+0)]=pixB; 
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+1)]=pixV; 
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+2)]=pixR; 
       dat[((lig+zoom_lig)*wdth*4)+((4*(col+zoom_col))+3)]=0; 
       }
    }
  } /*--------------------------------------------------------*/

  /*Zoom negatif*/
  /*------------*/
  else
  {
   z=-z;
   lgth=(length/z);
   wdth=(width/z);

   dat=(unsigned char*)malloc(lgth*(wdth*4)*sizeof(unsigned char));
   if (dat==NULL)
      { printf("Impossible d'allouer de la memoire.");
        exit(-1); }

  for(lig=0;lig<(lgth*z);lig=lig+z) for(col=0;col<(wdth*z);col=col+z)
   {  
    sum[0]=sum[1]=sum[2]=0.0;
    
    for(i=0;i<3;i++)
    for(zoom_lig=0;zoom_lig<z;zoom_lig++) for(zoom_col=0;zoom_col<z;zoom_col++)
     sum[i]+=matRVB[i][lig+zoom_lig][col+zoom_col];
       
    for(i=0;i<3;i++)  sum[i]/=(z*z); 

     dat[((lig/z)*wdth*4)+((4*(col/z))+0)]=(unsigned char)sum[1];
     dat[((lig/z)*wdth*4)+((4*(col/z))+1)]=(unsigned char)sum[1];
     dat[((lig/z)*wdth*4)+((4*(col/z))+2)]=(unsigned char)sum[1];
     dat[((lig/z)*wdth*4)+((4*(col/z))+3)]=(unsigned char)sum[1]; 
   }
  } /*--------------------------------------------------------*/

  imageX=XCreateImage(display,visual,depth,ZPixmap,0,(char*)dat,wdth,lgth,16,wdth*4);
  return (imageX);
}



//---------------------------------------------------------
// Enregistre les arguments de la ligne de commande      
//---------------------------------------------------------
void read_arguments(int argc,char** argv)
{
 int i;

   //Options
  if (argc<2) 
    { printf("\n Usage %s [Img. in ppm format]",argv[0]); 
      printf("\n Options : value by default indicated in ()");
      printf("\n            -----------------------------------------");
      printf("\n            -------------");
      printf("\n            -d NbDef   >[%d]",NBDEF);
      printf("\n            -p Param   >[%.2f]",PARM);
      printf("\n            -------------");
      printf("\n            -t TypDef  >[%d]",TYPDEF);
      printf("\n            -i DefVisu >[%d in [0::%d]",DEFVISU,NBDEF-1); 
      printf("\n            -------------");
      printf("\n            -z zoom (%d)",ZOOM);
      printf("\n            -v visu (%d)",VISU);
      printf("\n            -q quit (Sans)"); 
      printf("\n            -s save (Sans)"); 
      printf("\n            -------------");
      printf("\n");
      printf("\n  Example:  %s 134052.ppm",argv[0]);
      printf("\n\n\n\n\n");
      exit(-1); }

      //Chargement Fichier
      if (argc>1) strcpy(Name_img,argv[1]);
     
   //Boucle 
   for(i=2;i<argc;i++)
     {   
          switch(argv[i][1])
          {  
           case 'd': NbDef=atoi(argv[++i]);        break;
           case 'p': ParM=atof(argv[++i]);         break;

           case 't': TypDef=atoi(argv[++i]);       break;
           case 'i': DefVisu=atoi(argv[++i]);      break;
                    
           case 'z': zoom=atoi(argv[++i]);         break;
           case 'g': strcpy(Extension,argv[++i]);  break;
	   case 'v': flag_visu=1;                  break;
	   case 'q': flag_quit=1;                  break;
           case 's': flag_save=1;                  break;                   
          }    
     } 
 }

//----------------------------------------------------------
//----------------------------------------------------------
// MAIN PROGRAM --------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
int main(int argc,char** argv)
{
 int  flag;

 //>ForXwindow
 XEvent ev;

 Window win_ppicture_imag1;
 Window win_ppicture_imag2;
 Window win_ppicture_imag3;
 XImage *x_ppicture_imag1;
 XImage *x_ppicture_imag2;
 XImage *x_ppicture_imag3; 
 char nomfen_ppicture_imag1[NCHAR];
 char nomfen_ppicture_imag2[NCHAR];
 char nomfen_ppicture_imag3[NCHAR];
 
 //>Initialization
 NbDef=NBDEF;
 ParM=PARM;

 DefVisu=DEFVISU;
 TypDef=TYPDEF;
 
 zoom=ZOOM;
 flag_save=SAVE;
 flag_quit=QUIT;
 flag_visu=VISU;
 flag=0;

 //>ReadArguments
 read_arguments(argc,argv);

 if (DefVisu>=NbDef) 
    { printf("\n -i DefVisu  >[%d in [0::%d]\n\n",DEFVISU,NBDEF-1); 
      exit(-1); }

 //>DisplayOoptions
 printf("\n\n\n");
 printf("\n\n Information: ");
 printf("\n -----");
 printf("\n Ouverture de l'image : <%s>",Name_img); 
 printf("\n -----");  
 printf("\n NbDef     : [%d]",NbDef);
 printf("\n ParM      : [%.2F]",ParM);
 printf("\n -----");
 printf("\n TypDef    : [%d]",TypDef);
 printf("\n DefVisu   : [%d]",DefVisu);
 printf("\n -----");
 printf("\n Zoom: %d",zoom);
 printf("\n Visu: %d",flag_visu); 
 if (flag_save)  printf("\n -> Avec Sauvegarde");
 if (flag_quit)  printf("\n -> Avec Quit");
 fflush(stdout);

//-------------------------------
//---- Image Loading -------------------------------
//-------------------------------

 int length;
 int width;
 GetLengthWidth(Name_img,&length,&width);
 printf("\n Taille de l'image: [%d - %d]",length,width);
 fflush(stdout);

 float*** mat_imag1=fmatrix_allocate_3d(3,length,width);
 float*** mat_imag2=fmatrix_allocate_3d(3,length,width);
 load_image_ppm(Name_img,mat_imag1,length,width);

 //------------------------------------------
 //-------- Algo_BISDA
 //------------------------------------------
 BISDA gseg(mat_imag1,length,width);

  //>Options 
  gseg.ParM=ParM;
  gseg.NbDef=NbDef; 
  gseg.TypDef=TypDef;
  gseg.DefVisu=DefVisu;
  strcpy(gseg.Extension,Extension);
  strcpy(gseg.Name_Img,Name_img);

  //>DetectSymmetry
  gseg.DetecSymmetry();


 //------------------------------------------
 //> ForVisu <For a give threshold>
 //------------------------------------------
 //for(int k=0;k<TROIS;k++) 
 //for(int i=0;i<length;i++) for(int j=0;j<width;j++) mat_imag2[k][i][j]=mat_imag1[k][i][j];
 //AddThreshPotential(mat_imag2,gseg.mat_sym,length,width,35);
 //SaveImagePpm(Name_img,(char*)"AndSym",mat_imag2,length,width);
  
//---------------------------------------------------------------
//---------------- visu under XWINDOW ----------------------------
//---------------------------------------------------------------
 if (!flag_quit)
 {
 //>OpenGraphicalSession
 if (open_display()<0) printf(" Impossible d'ouvrir une session graphique");

 //>Comments
 sprintf(nomfen_ppicture_imag1,"Image : %s",Name_img);  
 sprintf(nomfen_ppicture_imag2,"Image : %s",Name_img);
 sprintf(nomfen_ppicture_imag3,"Image : %s",Name_img);
 
 //>WindowCreation 
 win_ppicture_imag2=fabrique_window(nomfen_ppicture_imag2,10,10,width,length,zoom);
 win_ppicture_imag1=fabrique_window(nomfen_ppicture_imag1,10,10,width,length,zoom);
 win_ppicture_imag3=fabrique_window(nomfen_ppicture_imag3,10,10,width,length,zoom);
 
 //>XimagesCreation 
 x_ppicture_imag2=cree_XimageCoul(mat_imag2,zoom,length,width);
 x_ppicture_imag1=cree_XimageCoul(gseg.mat_imgF,zoom,length,width);
 x_ppicture_imag3=cree_Ximage(gseg.mat_sym,zoom,length,width);
 
 printf("\n\n Pour quitter,appuyer sur la barre d'espace");
 fflush(stdout);

 //>EventLoop
  for(;;)
     {
      XNextEvent(display,&ev);
       switch(ev.type)
        {
         case Expose:
         XPutImage(display,win_ppicture_imag2,gc,x_ppicture_imag2,0,0,0,0,
                   x_ppicture_imag2->width,x_ppicture_imag2->height);
         XPutImage(display,win_ppicture_imag1,gc,x_ppicture_imag1,0,0,0,0,
                   x_ppicture_imag1->width,x_ppicture_imag1->height);    
         XPutImage(display,win_ppicture_imag3,gc,x_ppicture_imag3,0,0,0,0,
                   x_ppicture_imag3->width,x_ppicture_imag3->height);
         break;

         case KeyPress:
         XDestroyImage(x_ppicture_imag2);
         XDestroyImage(x_ppicture_imag1);
         XDestroyImage(x_ppicture_imag3); 

         XFreeGC(display,gc);
         XCloseDisplay(display);
         flag=1;
         break;
         }
   if (flag==1) break;
   }
 } 
       
//--------------- End Graphical Session --------------------     
//----------------------------------------------------------

   //>Ending
   printf("\n C'est fini... \n"); 
   return 0;
 }
 


