//---------------------------------------------------
// module  : BISDA.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

#ifndef BISDA_H
#define BISDA_H

//------------------------------------------------
// INCLUDED FILES --------------------------------
//------------------------------------------------
#include "FunctionBISDA.h"
#include "lsd.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define NCHAR 200

//------------------------------------------------
// PARAMETER MODEL -------------------------------
//------------------------------------------------

//>MAJOR_PARAMETERS
const int   NB_LINES=70; 
const int   NB_DEFOR=10;            
const float ADDIMGCART=0.48;    
const float PROP_WND=0.60; 
const float RES_MIN=0.25;  
const int   NB_RESOL=3;   
 
//>MINOR_PARAMETERS
const float SIGMA_DIST=0.10; 
const float DIST_ANLIN_MAX=2.05;               
const int   BORD=30;                  
const float POT_TEXT_EDGE=1.3; 
const float EXPCROSSLINE=2.25;      
const int   DIST_MIN=2;          
const int   NBGAUSSFILTPOT=1;    
const int   REMOVELASTLINE=5;         

//>INTERNAL_PARAMETERS
const float  RES_MAX=1.0; 
const int    NB_MAPS=NB_RESOL*3;
const double T_EPS=-20.0;              
const int    ACC=1;                  

//------------------------------------------------
// BISDA CLASS -------------------------
//------------------------------------------------
class BISDA
{
  //--Donnees--
  //-----------
  public:

  //>ImgMatrix
  int***   mat_img;
  float*** mat_imgF;
  float**  mat_sym;
  
  //>ParamIMG
  int width,length;

  //>Parameters
  float ParM;
 
  int NbDef;
  int DefVisu;
  int TypDef;

  //>Flag
  int  flag_save;

  //>ForString
  char Name_Sauve[NCHAR];
  char Name_Img[NCHAR];
  char Extension[NCHAR];  

  //--Methods--
  //------------
  public:
  BISDA(float***,int,int);
  ~BISDA();

  //--------------
  void DetecSymmetry();
  void FuncComputeSym(float***,float**,int,int);
};

#endif 
