//------------------------------------------------------
// module  : FunctionBISDA.cc
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionBISDA.h"
#include "BISDA.h"

//--------------------------//
//---- MATRIX_ALLOCATION ---//
//--------------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de float
//----------------------------------------------------------
float* fmatrix_allocate_1d(int hsize)
 {
  float* matrix;
  matrix=new float[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de float
//----------------------------------------------------------
float** fmatrix_allocate_2d(int vsize,int hsize)
 {
  float** matrix;
  float *imptr;

  matrix=new float*[vsize];
  imptr=new  float[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de float
//----------------------------------------------------------
float*** fmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  float*** matrix;

  matrix=new float**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=fmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 4d de float
//----------------------------------------------------------
float**** fmatrix_allocate_4d(int fsize,int dsize,int vsize,int hsize)
 {
  float**** matrix;

  matrix=new float***[fsize];

  for(int i=0;i<fsize;i++)
    matrix[i]=fmatrix_allocate_3d(dsize,vsize,hsize);
  return matrix;
 }

//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de int
//----------------------------------------------------------
int* imatrix_allocate_1d(int hsize)
 {
  int* matrix;
  matrix=new int[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de int
//----------------------------------------------------------
int** imatrix_allocate_2d(int vsize,int hsize)
 {
  int** matrix;
  int*  imptr;

  matrix=new int*[vsize];
  imptr=new  int[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de int
//----------------------------------------------------------
int*** imatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  int*** matrix;

  matrix=new int**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=imatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de <unsigned char>
//----------------------------------------------------------
unsigned char* cmatrix_allocate_1d(int hsize)
 {
  unsigned char* matrix;
  matrix=new unsigned char[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de <unsigned char>
//----------------------------------------------------------
unsigned char** cmatrix_allocate_2d(int vsize,int hsize)
 {
  unsigned char** matrix;
  unsigned char*  imptr;

  matrix=new unsigned char*[vsize];
  imptr=new  unsigned char[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de <unsigned char>
//----------------------------------------------------------
unsigned char*** cmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  unsigned char*** matrix;

  matrix=new unsigned char**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=cmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//----------------------------------------------------------
// libere la memoire de la matrice 1d de float
//----------------------------------------------------------
void free_fmatrix_1d(float* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de float
//----------------------------------------------------------
void free_fmatrix_2d(float** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de float
//----------------------------------------------------------
void free_fmatrix_3d(float*** pmat,int dsize)
{
 for(int i=0;i<dsize;i++)
  {
   delete[] (pmat[i][0]);
   delete[] (pmat[i]);
   }
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 4d de float
//----------------------------------------------------------
void free_fmatrix_4d(float**** pmat,int fsize,int dsize)
{
 for(int i=0;i<fsize;i++)
  free_fmatrix_3d(pmat[i],dsize);
  
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 1d de int
//----------------------------------------------------------
void free_imatrix_1d(int* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de int
//----------------------------------------------------------
void free_imatrix_2d(int** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de int
//----------------------------------------------------------
void free_imatrix_3d(int*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }

//----------------------------------------------------------
// libere la memoire de la matrice 1d de <unsigned char>
//----------------------------------------------------------
void free_cmatrix_1d(unsigned char* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de <unsigned char>
//----------------------------------------------------------
void free_cmatrix_2d(unsigned char** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de <unsigned char>
//----------------------------------------------------------
void free_cmatrix_3d(unsigned char*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }

//--------------------//
//-- Matrix_Gestion --//
//--------------------//
//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void copy_mat(float** pmatl1,float** pmatl2,int lgth,int wdth)
{

  for(int i=0;i<lgth;i++) for(int j=0;j<wdth;j++)
     { pmatl2[i][j]=pmatl1[i][j]; }
}

//----------------------------------------------------------
//  AverageMat
//----------------------------------------------------------
void AverageMat(float*** TabMatIn,float** MatOut,int lgth,int wdth,int number)
{
 int i,j,k;
  
 //Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  MatOut[i][j]=0.0;

 //Average
 for(k=0;k<number;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  MatOut[i][j]+=TabMatIn[k][i][j];

 //Norm
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  MatOut[i][j]/=(number);
}

//----------------------------------------------------------
// Recal                                                    
//----------------------------------------------------------
void Recal(float** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 /*Initialisation*/
 max=-1000000.0;
 min=100000000;

 /*Recherche du min*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 /*plus min*/
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]-=min;

 /*Recherche du max*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 /*Recalibre la matrice*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   if (max) mat[i][j]*=(GREY_LEVEL/max);      
}


//--------------------//
//-- LOAD/SAVE_FILE --//
//--------------------//
//----------------------------------------------------------
// Get Length and Width
//----------------------------------------------------------
void GetLengthWidth(char* path,int* length,int* width)
{
 unsigned char var;
 int   temp;
 char* tempc;
 char stringTmp1[100];
 char stringTmp2[100];
 int ta1,ta2;
 FILE *fic;

  //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL)
    { printf("\n- Grave erreur a l'ouverture de %s -\n",path);
      exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic);
  for(;;) { temp=fread(&var,1,1,fic); if (var==35) tempc=fgets(stringTmp2,100,fic);
            else break; }
  fseek(fic,-1,SEEK_CUR);
  temp=fscanf(fic,"%d %d",&ta1,&ta2);
   
  //enregistrement
  (*length)=ta2; 
  (*width)=ta1;

  //fermeture du fichier
  fclose(fic);
}

//----------------------------------------------------------
// Chargement de l'image de nom <name> (en ppm)             
//----------------------------------------------------------
void load_image_ppm(char* path,float*** img,int lgth,int wdth)
 {
  int i,j;
  int temp;
  char* tempc;
  unsigned char varb,varv,varr;

  char stringTmp1[200],stringTmp2[200];
  int ta1,ta2,ta3;
  FILE *fic;

  //enregistrement du chemin;
   if (strstr(path,".ppm")==NULL) strcat(path,".ppm");

   //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL) 
   { printf("\n ->> Grave erreur a l'ouverture de %s -\n",path);
     exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic); //P6
  tempc=fgets(stringTmp2,100,fic); //Comment

  for(;;)
    { if (((int)stringTmp2[0]==10)||((int)stringTmp2[0]==35))
      tempc=fgets(stringTmp2,100,fic); 

      else break; }

  temp=sscanf(tempc," %d %d",&ta1,&ta2);
  temp=fscanf(fic," %d",&ta3);
   
  //chargement dans la matrice
  for(i=0;i<lgth;i++) for(j=0;j<(wdth*3);j+=3)  
    { temp=fread(&varr,1,1,fic);
      temp=fread(&varv,1,1,fic);
      temp=fread(&varb,1,1,fic);
     
      img[2][i][j/3]=varr;        
      img[0][i][j/3]=varv;        
      img[1][i][j/3]=varb; }      

  //fermeture du fichier
  fclose(fic);
 }

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,float** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n Sauvegarde de %s au format pgm\n",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(char* Path_out,char* Name,float*** matrvb,int wdth,int lgth)
 {
  int i,j;
  char buff[200];
  FILE* fuser;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,".ppm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n sauvegarde dans -> %s au format %s [%d][%d]",buff,".ppm",wdth,lgth);
  fflush(stdout);

  //sauvegarde de l'entete
  fprintf(fuser,"P6");
  fprintf(fuser,"\n# IMG Module");
  fprintf(fuser,"\n%d %d",lgth,wdth);
  fprintf(fuser,"\n255\n");

  //enregistrement
  for(i=0;i<wdth;i++) for(j=0;j<lgth;j++) 
    {
     fprintf(fuser,"%c",(char)matrvb[0][i][j]);
     fprintf(fuser,"%c",(char)matrvb[1][i][j]);
     fprintf(fuser,"%c",(char)matrvb[2][i][j]);
    }
       
  //fermeture fichier
   fclose(fuser); 
 }

//---------------------------
//---------------------------
// LOG_POLAR_MAPPING                    
//---------------------------
//---------------------------
//---------------------------------------------------
// LogPolarMapping                      
//---------------------------------------------------
void LogPolarMapping(float** imgIn,float** imgOut,int lgth,int wdth,int RowDec,int ColDec,int inverse,int BilInterp)  
{
 int i,j;
 int col_inf,col_sup;
 int row_inf,row_sup;
 float row,col;
 float t,u;
 float ng;

 float Dist,Angle;
 const float RADIAN=2.0*PI/360.0;

 int RowCenter=(int)((lgth/2))+RowDec;
 int ColCenter=(int)((wdth/2))+ColDec;
 double WDTH_MAX=360.0;
 double LGTH_MAX=log(sqrt(CARRE((lgth/2)+abs(RowDec))+CARRE((wdth/2)+abs(ColDec))));
 double ScalWdth=WDTH_MAX/(double)wdth;
 double ScalLgth=LGTH_MAX/(double)lgth;

 //Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) imgOut[i][j]=0;

 //PolarMapping
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     {
      if (!inverse)
	{ Dist=exp(((float)i*ScalLgth));
          row=RowCenter+(Dist*sin(j*ScalWdth*RADIAN));
	  col=ColCenter+(Dist*cos(j*ScalWdth*RADIAN));  }

      if (inverse)
	 { Dist=log(sqrt(CARRE(i-RowCenter)+CARRE(j-ColCenter)));
           Dist/=ScalLgth;
	   Angle=atan2((i-RowCenter),(j-ColCenter));
           if (Angle<0) Angle+=2*PI;
           Angle*=wdth/((float)(2.0*PI));        
           row=Dist;
           col=Angle; }

      if ((int)row>(lgth-1))  continue;
      if ((int)row<0)         continue;
      if ((int)col>(wdth-1))  continue;
      if ((int)col<0)         continue;

      col_inf=(int)(col);
      col_sup=(int)(col+1);
      row_inf=(int)(row);
      row_sup=(int)(row+1);

      if (col_sup>(wdth-1)) col_sup=(wdth-1);
      if (col_sup<0)        col_sup=0; 
      if (col_inf>(wdth-1)) col_inf=(wdth-1);
      if (col_inf<0)        col_inf=0;
      if (row_sup>(lgth-1)) row_sup=(lgth-1);
      if (row_sup<0)        row_sup=0; 
      if (row_inf>(lgth-1)) row_inf=(lgth-1);
      if (row_inf<0)        row_inf=0;

      //LinearInterpol
      imgOut[i][j]=imgIn[(int)row][(int)col];

      //BilinearInterpol
      if (BilInterp)
      {
      t=u=0.0;
      if (col_sup-col_inf) t=(col-col_inf)/(col_sup-col_inf);
      if (row_sup-row_inf) u=(row-row_inf)/(row_sup-row_inf);
     	
      ng=(1-t)*(1-u)*imgIn[row_inf][col_inf];
      ng+=t*(1-u)*imgIn[row_inf][col_sup];
      ng+=t*u*imgIn[row_sup][col_sup];
      ng+=(1-t)*u*imgIn[row_sup][col_inf];
      if (ng>255) ng=255;
      if (ng<0)   ng=0; 
      if isnan(ng) { ng=0; printf("*"); }
      imgOut[i][j]=(int)ng;
      } 
  }
}

//---------------------------------------------------
// LogPolarMapping                      
//---------------------------------------------------
void LogPolarMapping(float*** imgIn,float*** imgOut,int lgth,int wdth,int RowDec,int ColDec,int inverse,int BilInterp)  
{
 int i,j,k;
 int col_inf,col_sup;
 int row_inf,row_sup;
 float row,col;
 float t,u;
 float ng;

 float Dist,Angle;
 const float RADIAN=2.0*PI/360.0;

 int RowCenter=(int)((lgth/2))+RowDec;
 int ColCenter=(int)((wdth/2))+ColDec;
 double WDTH_MAX=360.0;
 double LGTH_MAX=log(sqrt(CARRE((lgth/2)+abs(RowDec))+CARRE((wdth/2)+abs(ColDec))));
 double ScalWdth=WDTH_MAX/(double)wdth;
 double ScalLgth=LGTH_MAX/(double)lgth;

 //Init
 for(k=0;k<3;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) imgOut[k][i][j]=0;

 //PolarMapping
 for(k=0;k<3;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     {
      if (!inverse)
	{ Dist=exp(((float)i*ScalLgth));
          row=RowCenter+(Dist*sin(j*ScalWdth*RADIAN));
	  col=ColCenter+(Dist*cos(j*ScalWdth*RADIAN));  }

      if (inverse)
	 { Dist=log(sqrt(CARRE(i-RowCenter)+CARRE(j-ColCenter)));
           Dist/=ScalLgth;
	   Angle=atan2((i-RowCenter),(j-ColCenter));
           if (Angle<0) Angle+=2*PI;
           Angle*=wdth/((float)(2.0*PI));        
           row=Dist;
           col=Angle; }

      if ((int)row>(lgth-1))  continue;
      if ((int)row<0)         continue;
      if ((int)col>(wdth-1))  continue;
      if ((int)col<0)         continue;

      col_inf=(int)(col);
      col_sup=(int)(col+1);
      row_inf=(int)(row);
      row_sup=(int)(row+1);

      if (col_sup>(wdth-1)) col_sup=(wdth-1);
      if (col_sup<0)        col_sup=0; 
      if (col_inf>(wdth-1)) col_inf=(wdth-1);
      if (col_inf<0)        col_inf=0;
      if (row_sup>(lgth-1)) row_sup=(lgth-1);
      if (row_sup<0)        row_sup=0; 
      if (row_inf>(lgth-1)) row_inf=(lgth-1);
      if (row_inf<0)        row_inf=0;

      //LinearInterpol
      imgOut[k][i][j]=imgIn[k][(int)row][(int)col];

      //BilinearInterpol
      if (BilInterp)
      {
      t=u=0.0;
      if (col_sup-col_inf) t=(col-col_inf)/(col_sup-col_inf);
      if (row_sup-row_inf) u=(row-row_inf)/(row_sup-row_inf);
     	
      ng=(1-t)*(1-u)*imgIn[k][row_inf][col_inf];
      ng+=t*(1-u)*imgIn[k][row_inf][col_sup];
      ng+=t*u*imgIn[k][row_sup][col_sup];
      ng+=(1-t)*u*imgIn[k][row_sup][col_inf];
      if (ng>255) ng=255;
      if (ng<0)   ng=0; 
      if isnan(ng) printf("*");
      imgOut[k][i][j]=(int)ng; 
      }
   }
}

//---------------------------
//---------------------------
// PRE-TRAITMENT                    
//---------------------------
//---------------------------
//------------------------------------------------------------
// FillHoleImg                    
//------------------------------------------------------------
void FillHoleImg(float*** ImgIn,int lgth,int wdth,int Sz)  
{
 int i,j,k,l,m;
 int posr,posc;
 int cpt;
 float val;

 //AllocateMemory
 float*** ImgOut=fmatrix_allocate_3d(3,lgth,wdth);

 //Init
 for(k=0;k<3;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgOut[k][i][j]=ImgIn[k][i][j];

 //Loop
 for(k=0;k<3;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (!ImgOut[k][i][j])
    {
     val=0.0;
     cpt=0;
     for(l=-Sz;l<=Sz;l++) for(m=-Sz;m<=Sz;m++)
        { posr=i+l;
          posc=j+m;
          if (posr>(lgth-1)) posr=(lgth-1);
          if (posr<0)        posr=0;
          if (posc>(wdth-1)) posc=(wdth-1);
          if (posc<0)        posc=0;
          if (ImgOut[k][posr][posc]) { cpt++; val+=ImgOut[k][posr][posc]; } }
     if (cpt) val/=(float)cpt;

     ImgOut[k][i][j]=(int)val;     
    }

 //Transfert 
 for(k=0;k<3;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgIn[k][i][j]=ImgOut[k][i][j];

 //FreeMemory
 if (ImgOut) free_fmatrix_3d(ImgOut,3);
}

//------------------------------------------------------------
// FindRegSpacedPts [Sur Diagonale]
// [0] RowDec
// [1] ColDec                
//------------------------------------------------------------
void FindRegSpacedPts(int lgth,int wdth,float PropWnd,int Number,int** TabPts,int** TabPtsInc)  
{
 int k;
 float RowCenter,ColCenter;
 float RowBeg,ColBeg;
 float RowEnd,ColEnd;
 float EcartRow,EcartCol;

 //>Init
 ColCenter=wdth/2;
 RowCenter=lgth/2;

 ColBeg=ColCenter-(PropWnd*ColCenter);
 RowBeg=RowCenter-(PropWnd*RowCenter);
 ColEnd=ColCenter+(PropWnd*ColCenter);
 RowEnd=RowCenter+(PropWnd*RowCenter);
 EcartRow=RowEnd-RowBeg;
 EcartCol=ColEnd-ColBeg;

 //>FillTabPts
 if (Number>1) { EcartRow/=(float)(Number-1); EcartCol/=(float)(Number-1); }
 else { EcartRow=0; EcartCol=0; }

 //>Info
 //printf("<%f::%f>",EcartRow,EcartCol);

 if (EcartRow)
 for(k=0;k<Number;k++)
   { TabPts[k][0]=(int)(RowBeg+(k*EcartRow));
     TabPts[k][1]=(int)(ColBeg+(k*EcartCol));
     TabPtsInc[k][0]=TabPts[k][0]-(lgth/2);
     TabPtsInc[k][1]=TabPts[k][1]-(wdth/2); }

 else { TabPts[0][0]=(int)RowCenter;
        TabPts[0][1]=(int)ColCenter;
        TabPtsInc[0][0]=0;
        TabPtsInc[0][1]=0; }
}

//--------------------------------
//--------------------------------
//--ENDING------------------------
//--------------------------------
//--------------------------------
//---------------------------------------------------------
// AddMatrix
//----------------------------------------------------------
void AddMatrix(float** MtLab1,float** MtLab2,float** MtLab,int lgth,int wdth,float alpha)
{
 int i,j;

 //>Add
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 MtLab[i][j]=((1.0-alpha)*MtLab1[i][j])+(alpha*MtLab2[i][j]);
}

//----------------------------------------------------------*/
// GaussianFilter
//----------------------------------------------------------*/
void GaussianFilter2(float** img,float** imgout,int lgth,int wdth)
{
 int i,j;
 float tmp;

 //Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) imgout[i][j]=img[i][j];

 //>Filtrage
 for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
    { tmp=16*img[i][j];
      tmp+=4*img[i+1][j];
      tmp+=4*img[i-1][j];
      tmp+=4*img[i][j+1];
      tmp+=4*img[i][j-1];
      tmp+=img[i+1][j+1];
      tmp+=img[i-1][j-1];
      tmp+=img[i-1][j+1];
      tmp+=img[i+1][j-1];
      tmp/=36.0;
      tmp=(int)(tmp+0.5);
      imgout[i][j]=tmp; }
}

//----------------------------------------------------------*/
// GaussianFilterN
//----------------------------------------------------------*/
void GaussianFilter2N(float** img,int lgth,int wdth,int nb)
{
 int i,j,k;

 //>Memory Allocation
 float** mat=fmatrix_allocate_2d(lgth,wdth);
 float** matout=fmatrix_allocate_2d(lgth,wdth);

 //>Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=img[i][j];
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matout[i][j]=img[i][j];

 //>Filtrage
 for(k=0;k<nb;k++) 
   { GaussianFilter2(mat,matout,lgth,wdth);
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=matout[i][j]; }

 //>Transfert
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) img[i][j]=matout[i][j];

 //>FreeMemory
 if (mat)    free_fmatrix_2d(mat);
 if (matout) free_fmatrix_2d(matout);
}

//----------------------------------------------------------
// NonMaxLocSuppr
// --------------
//   ____x      ___0   \       |     /                                 
//  |                   \ 1    | 2  / 3                                 
//  |                                                                   
//  y 
//      >> Le long du contour (de symmetrie)
//----------------------------------------------------------    
void NonMaxLocSuppression(float** matgrd,int*** Img,float** matout,int lgth,int wdth,float ess)
{
 int i,j,c;
 float k;
 float tmp;
 float Gx,Gy,Gx1,Gy1,Gx2,Gy2,Gx3,Gy3;
 float min,est;
 
 //>Allocation memoire
 float** matgrdsuppr=fmatrix_allocate_2d(lgth,wdth);
 float** matorient=fmatrix_allocate_2d(lgth,wdth);
 float** mattmp=fmatrix_allocate_2d(lgth,wdth);
 float** matNB=fmatrix_allocate_2d(lgth,wdth);
 float*** matallorient=fmatrix_allocate_3d(5,lgth,wdth);

 //>Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { matgrdsuppr[i][j]=0.0;
      mattmp[i][j]=0.0; }

 for(c=0;c<4;c++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matallorient[c][i][j]=0.0;

 //>MatriceN&B
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matNB[i][j]=0.3333*(Img[0][i][j]+Img[1][i][j]+Img[2][i][j]);

 //>Filtrage
 GaussianFilter2N(matNB,lgth,wdth,3);

 //>Orientation
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matorient[i][j]=0.0;

   //>Essai-0-
   if (ess==0)
   for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
      { Gx1=(matNB[i][j-1]-matNB[i][j+1]); 
        Gy1=(matNB[i+1][j]-matNB[i-1][j]); 
        if (Gy1) matorient[i][j]+=atan(Gx1/Gy1); 
        else     matorient[i][j]=(PI/2.0); }

   //>Essai-1-
   if (ess==1)
   for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
      { Gx1=(matNB[i][j-1]-matNB[i][j+1]); 
        Gy1=(matNB[i+1][j]-matNB[i-1][j]);
        Gx2=(matNB[i-1][j-1]-matNB[i+1][j+1]); 
        Gy2=(matNB[i+1][j-1]-matNB[i-1][j+1]); 

        if (Gy1) { tmp=atan(Gx1/Gy1);  
                   if (tmp<0)  tmp+=PI; 
                   if (tmp>PI) tmp-=PI;   
                   matorient[i][j]+=tmp; } 
        else     matorient[i][j]+=(PI/2.0); 

        if (Gy2) { tmp=(PI/4.0)+atan(Gx2/Gy2);  
                   if (tmp<0)  tmp+=PI; 
                   if (tmp>PI) tmp-=PI; 
                   matorient[i][j]+=tmp; } 
        else     matorient[i][j]+=(PI/4.0)+(PI/2.0); 

        matorient[i][j]/=2.0; 
        if (matorient[i][j]>PI) matorient[i][j]-=PI; 
        if (matorient[i][j]<0)  matorient[i][j]+=PI; }

   //>Essai-2-
  if (ess==2)
  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
     { Gx1=(Img[0][i][j-1]-Img[0][i][j+1]); 
       Gy1=(Img[0][i+1][j]-Img[0][i-1][j]); 
       Gx2=(Img[1][i][j-1]-Img[1][i][j+1]); 
       Gy2=(Img[1][i+1][j]-Img[1][i-1][j]);
       Gx3=(Img[2][i][j-1]-Img[2][i][j+1]); 
       Gy3=(Img[2][i+1][j]-Img[2][i-1][j]);
       
       if (Gy1) { tmp=atan(Gx1/Gy1);
                  if (tmp<0)  tmp+=PI; 
                  if (tmp>PI) tmp-=PI;  
                  matorient[i][j]+=tmp; }
       else     matorient[i][j]+=(PI/2.0);

       if (Gy2) { tmp=atan(Gx2/Gy2);
                  if (tmp<0)  tmp+=PI; 
                  if (tmp>PI) tmp-=PI;  
                  matorient[i][j]+=tmp; }
       else     matorient[i][j]+=(PI/2.0); 

       if (Gy3) { tmp=atan(Gx3/Gy3);
                  if (tmp<0)  tmp+=PI; 
                  if (tmp>PI) tmp-=PI;  
                  matorient[i][j]+=tmp; }
       else     matorient[i][j]+=(PI/2.0);  
      
       matorient[i][j]/=3.0; 
       if (matorient[i][j]>PI) matorient[i][j]-=PI; 
       if (matorient[i][j]<0)  matorient[i][j]+=PI; }

  //>Essai-3-
   if (ess==3)
   for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
      { Gx1=(matgrd[i][j-1]-matgrd[i][j+1]); 
        Gy1=(matgrd[i+1][j]-matgrd[i-1][j]); 
        if (Gy1) matorient[i][j]+=atan(Gx1/Gy1); 
        else     matorient[i][j]+=(PI/2.0); }
 
   //>Essai-4-
   if (ess==4)
   for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
      { Gx=(matgrd[i][j-1]-matgrd[i][j+1]);
        Gy=(matgrd[i+1][j]-matgrd[i-1][j]);
        Gx1=(matNB[i][j-1]-matNB[i][j+1]); 
        Gy1=(matNB[i+1][j]-matNB[i-1][j]); 
     
        if (Gy)  { tmp=atan(Gx/Gy); 
                   if (tmp<0)  tmp+=PI; 
                   if (tmp>PI) tmp-=PI;
                   matorient[i][j]+=tmp; }
        else     matorient[i][j]+=(PI/2.0);  

        if (Gy1) { tmp=atan(Gx1/Gy1);
                   if (tmp<0)  tmp+=PI; 
                   if (tmp>PI) tmp-=PI;
                   matorient[i][j]+=tmp; }
        else     matorient[i][j]+=(PI/2.0);

        matorient[i][j]/=2.0; 
        if (matorient[i][j]>PI) matorient[i][j]-=PI; 
        if (matorient[i][j]<0)  matorient[i][j]+=PI; }

    //>Essai-5-
  if (ess==5)
  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
     { Gx=(matgrd[i][j-1]-matgrd[i][j+1]);
       Gy=(matgrd[i+1][j]-matgrd[i-1][j]);
       Gx1=(Img[0][i][j-1]-Img[0][i][j+1]); 
       Gy1=(Img[0][i+1][j]-Img[0][i-1][j]); 
       Gx2=(Img[1][i][j-1]-Img[1][i][j+1]); 
       Gy2=(Img[1][i+1][j]-Img[1][i-1][j]);
       Gx3=(Img[2][i][j-1]-Img[2][i][j+1]); 
       Gy3=(Img[2][i+1][j]-Img[2][i-1][j]);
       
       if (Gy)  { tmp=atan(Gx/Gy); 
                  if (tmp<0)  tmp+=PI; 
                  if (tmp>PI) tmp-=PI; 
                  matorient[i][j]+=tmp; }
       else     matorient[i][j]+=(PI/2.0);
       
       if (Gy1) { tmp=atan(Gx1/Gy1);
                  if (tmp<0)  tmp+=PI; 
                  if (tmp>PI) tmp-=PI;  
                  matorient[i][j]+=tmp; }
       else     matorient[i][j]+=(PI/2.0);

       if (Gy2) { tmp=atan(Gx2/Gy2);
                  if (tmp<0)  tmp+=PI; 
                  if (tmp>PI) tmp-=PI;  
                  matorient[i][j]+=tmp; }
       else     matorient[i][j]+=(PI/2.0); 

       if (Gy3) { tmp=atan(Gx3/Gy3);
                  if (tmp<0)  tmp+=PI; 
                  if (tmp>PI) tmp-=PI;  
                  matorient[i][j]+=tmp; }
       else     matorient[i][j]+=(PI/2.0);  
      
       matorient[i][j]/=4.0; 
       if (matorient[i][j]>PI) matorient[i][j]-=PI; 
       if (matorient[i][j]<0)  matorient[i][j]+=PI; }
  
 //Normalisation_[0-PI]
 for(i=0;i<lgth-1;i++) for(j=0;j<wdth-1;j++) 
     if (matorient[i][j]<0) matorient[i][j]+=PI;

  //>A 45 degre pres
  for(i=0;i<(lgth-1);i++) for(j=0;j<(wdth-1);j++)
     { min=10000000; est=0;
       for(k=0.0,c=0;k<=PI;k=k+(PI/4),c++)
         { tmp=fabs(matorient[i][j]-k);
           if (tmp<min) { min=tmp; est=c;} }

       if(est==4) est=0;
       matorient[i][j]=est;  }

 //>Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matgrdsuppr[i][j]=0.0;

 //>Suppression NonMaximumLocaux
  for(i=1;i<lgth-1;i++) for(j=1;j<wdth-1;j++)
    { matgrdsuppr[i][j]=matgrd[i][j];
      
     if (matorient[i][j]==2.0)
        { if ((matgrd[i][j]<matgrd[i][j+1])||(matgrd[i][j]<matgrd[i][j-1]))  
	  matgrdsuppr[i][j]=0.0;  } 

     if (matorient[i][j]==1.0)
        { if ((matgrd[i][j]<matgrd[i+1][j-1])||(matgrd[i][j]<matgrd[i-1][j+1]))  
	  matgrdsuppr[i][j]=0.0;  }  
    
     if (matorient[i][j]==0.0)
        { if ((matgrd[i][j]<matgrd[i+1][j])||(matgrd[i][j]<matgrd[i-1][j])) 
	  matgrdsuppr[i][j]=0.0;  } 

     if (matorient[i][j]==3.0)
        { if ((matgrd[i][j]<matgrd[i+1][j+1])||(matgrd[i][j]<matgrd[i-1][j-1])) 
	  matgrdsuppr[i][j]=0.0;  }  }

 //>Transfert
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matout[i][j]=matgrdsuppr[i][j];

 //>Liberation memoire 
 free_fmatrix_2d(matgrdsuppr);
 free_fmatrix_2d(matorient);
 free_fmatrix_2d(mattmp);
 free_fmatrix_2d(matNB);
 free_fmatrix_3d(matallorient,3);
}

//---------------------------------------------------------
// RemoveIsolatedPix
//---------------------------------------------------------
void RemoveIsolatedPix(float** Img,int lgth,int wdth,int nb)
{
 int i,j,m,n;
 int flag,cpt;

 //Filtering
 cpt=0;
 for(i=nb;i<(lgth-nb);i++) for(j=nb;j<(wdth-nb);j++)
    {
     flag=0;
     if (Img[i][j])
        {
         for(m=-nb;m<=nb;m++) for(n=-nb;n<=nb;n++) 
	 if (m||n) if (Img[i+m][j+n]) flag=1; 

         if ((!flag)&&(nb)) { Img[i][j]=0.0; cpt++; }
        } 
    }

 //Info
 printf("[cpt=%d]",cpt);
}

//-------------------------------------------------------
// RemoveLastLineColumn                
//-------------------------------------------------------
void RemoveLastLineColumn(float** Mat,int lgth,int wdth,int nb)
{
 int i,j;

 //Remove
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { if (i<nb)          Mat[i][j]=0.0;
      if (i>(lgth-1-nb)) Mat[i][j]=0.0;
      if (j<nb)          Mat[i][j]=0.0;
      if (j>(wdth-1-nb)) Mat[i][j]=0.0;  }
}

//--------------------------//
//----TEXTURE_POTENTIAL-----//
//--------------------------//
//----------------------------------------------------------
// GradTexColor (dist=3 | div=5 | SzW=7)
//----------------------------------------------------------     
void GradTexColor(int*** img,float** matgrd,int lgth,int wdth,int dist,int div,int SzW)
 { 
  short int i,j,k,l;
  short int posr,posc;
  short int rowU,colU,rowD,colD;
  short int rowL,colL,rowR,colR;
  short int NbParam;
  short int lab;
  float grad,divis,max;

  //Constantes
  const short int div2=(div*div); 
  const short int SzwDiv2=SzW/2;

  //Initialization
  NbParam=div*div*div; 
  divis=(256.0/(float)div); 

  //Presentation
  printf("\n > Calcul Textural Gradient/Color");
  fflush(stdout);

  //MemoryAllocation
  unsigned char*** MatHis=cmatrix_allocate_3d(NbParam,lgth,wdth);

  //Initialization
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matgrd[i][j]=0.0;    
  for(k=0;k<NbParam;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatHis[k][i][j]=0; 

  //=================
  //==ALGO===========
  //=================

    //Compute HistoColor
    //------------------
      for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
        {
         for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
            { posr=i-(SzwDiv2)+k;
              posc=j-(SzwDiv2)+l;
              if (posr<0)           posr+=lgth;
              if (posr>(lgth-1))    posr-=lgth;  
              if (posc<0)           posc+=wdth;
              if (posc>(wdth-1))    posc-=wdth;
   
              lab=((short int)(img[0][posr][posc]/divis))*(div2);
              lab+=((short int)(img[1][posr][posc]/divis))*(div);  
              lab+=((short int)(img[2][posr][posc]/divis));
   
              MatHis[lab][i][j]++; }
        }
    
  //Compute GradText
  //----------------
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    { rowU=(i-dist); colU=j;
      rowD=(i+dist); colD=j;
      if (rowU<0)        rowU+=lgth;
      if (rowD>(lgth-1)) rowD-=lgth;
      rowL=i; colL=(j-dist);
      rowR=i; colR=(j+dist);
      if (colL<0)        colL+=wdth;
      if (colR>(wdth-1)) colR-=wdth;

      grad=0;
      for(l=0;l<NbParam;l++) 
         { grad+=abs(MatHis[l][rowU][colU]-MatHis[l][rowD][colD]);
           grad+=abs(MatHis[l][rowR][colR]-MatHis[l][rowL][colL]); 
           grad+=abs(MatHis[l][rowU][colL]-MatHis[l][rowD][colR]); 
           grad+=abs(MatHis[l][rowU][colR]-MatHis[l][rowD][colL]); }

       matgrd[i][j]+=grad;
    }

 //===================
 
  //==============================
  //Normalize
  //==============================
  max=0.0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) { if (matgrd[i][j]>max) max=matgrd[i][j]; }
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  matgrd[i][j]=((matgrd[i][j]*255.0)/max);
  //==============================

  //DEBUG
  //SaveImagePgm("","ImagePot",matgrd,lgth,wdth);

  //Liberation Memoire
  if (MatHis) free_cmatrix_3d(MatHis,NbParam); 
 }

//----------------------------------------------------------
// AddContour
//----------------------------------------------------------
void AddGradImg(int*** img,float** seg,float** segout,int lgth,int wdth,float fact)
{
 int i,j,k;
 float tmp;
 float gx,gy;

  //>Memory Allocation
  float** imgNB=fmatrix_allocate_2d(lgth,wdth);
  float** matgrd=fmatrix_allocate_2d(lgth,wdth);

  //>Init
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
  imgNB[i][j]=(1.0/3.0)*(img[0][i][j]+img[1][i][j]+img[2][i][j]);

  //>Gradient [3 Possibilites]
  //==========================
  //Gradient du vecteur couleur
  if (0)
     { for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
         { tmp=0.0;
           if (0)
	      { for(k=0;k<3;k++) tmp+=CARRE(img[k][i+1][j]-img[k][i-1][j]);
                for(k=0;k<3;k++) tmp+=CARRE(img[k][i][j+1]-img[k][i][j-1]);
                for(k=0;k<3;k++) tmp+=CARRE(img[k][i+1][j+1]-img[k][i-1][j-1]);
                for(k=0;k<3;k++) tmp+=CARRE(img[k][i-1][j+1]-img[k][i+1][j-1]); }

           if (1)
	      { for(k=0;k<3;k++) tmp+=fabs(img[k][i+1][j]-img[k][i-1][j]);
                for(k=0;k<3;k++) tmp+=fabs(img[k][i][j+1]-img[k][i][j-1]);
                for(k=0;k<3;k++) tmp+=fabs(img[k][i+1][j+1]-img[k][i-1][j-1]);
                for(k=0;k<3;k++) tmp+=fabs(img[k][i-1][j+1]-img[k][i+1][j-1]); }
           matgrd[i][j]=sqrt(tmp); }

       Recal(matgrd,lgth,wdth); }

  //Gradient pixels N&B
  if (0)
    { for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
      matgrd[i][j]=sqrt(CARRE(imgNB[i+1][j]-imgNB[i-1][j])+CARRE(imgNB[i][j+1]-imgNB[i][j-1]));
      Recal(matgrd,lgth,wdth); }

  //Gradient Norm2 2x2 window
  if (1)
    { for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
	{ gx=(imgNB[i][j+1]+imgNB[i+1][j+1])-(imgNB[i][j]+imgNB[i+1][j]);
          gy=(imgNB[i+1][j]+imgNB[i+1][j+1])-(imgNB[i][j]+imgNB[i][j+1]);
          tmp=(gx*gx)+(gy*gy);
          tmp=sqrt(tmp/4.0);
          matgrd[i][j]=tmp; } 

      Recal(matgrd,lgth,wdth); 
    }

  
  //===========================

  //>Add
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) segout[i][j]=matgrd[i][j]+(fact*seg[i][j]);
  Recal(segout,lgth,wdth);

  //>FreeMemory
  if (imgNB)  free_fmatrix_2d(imgNB);
  if (matgrd) free_fmatrix_2d(matgrd);
}

//--------------------------//
//----SYMMETRY_GESTION -----//
//--------------------------//
//----------------------------------------------------------           
// Angle
//----------------------------------------------------------
float Angle(int y0,int x0,int y1,int x1)
{
 float gx,gy;
 float Angle;
 
 //Calcul_Angle
 gx=(x1-x0);
 gy=(y1-y0);
 Angle=atan2(gy,gx);
 if (Angle<0) Angle+=PI;

 //Retour
 return Angle;
}

//----------------------------------------------------------           
// AngleLine angle entre(Angle1 et Angle2)
//----------------------------------------------------------
float AngleLine(float Angle1,float Angle2)
{
 float Angle;
 
 //Calcul_Angle
 Angle=fabs(Angle1-Angle2);
 if (Angle<0)  Angle+=PI; 
 if (Angle>PI) Angle-=PI; 

 //Retour
 return Angle;
}

//----------------------------------------------------------
// DistBetweenPts
//----------------------------------------------------------
float DistBetwPts(int x0,int y0,int x1,int y1)
{
 return sqrt(CARRE(x0-x1)+CARRE(y0-y1));
}

//----------------------------------------------------------           
// DistAngle: Angle1-Angle2 [PI]
//
//              ---Angle2----* 
//                          /
//                      Angle1  
//                        /
//                       *
//----------------------------------------------------------
float DistAngle(int y0,int x0,int y1,int x1,float Angle2)
{
 float gx,gy;
 float Angle1;
 float DistAngle;
 
 //Calcul_Angle1
 gx=(x1-x0);
 gy=(y1-y0);
 Angle1=atan2(gy,gx);
 if (Angle1<0) Angle1+=PI;

 //Distance
 DistAngle=fabs(fmod((Angle1-Angle2),PI));

 //Retour
 return DistAngle;
}

//----------------------------------------------------------           
// Angular Symmetry Weighting 
//
//   ____x    ---*---  Phi_ij=2   ------*-  Phi_ij=1                             
//  |         ---*---             -*------                      
//  |                                                                   
//  y   
//            ---------------*- Phi_ij=0
//            -*---------------                                                               
//----------------------------------------------------------
float AngularSymmetryWeighting(int y0,int x0,int y1,int x1,float Phi1,float Phi2)
{
 float PhiIJ;
 float ThetaIJ=Angle(y0,x0,y1,x1);

 PhiIJ=1-cos(Phi1+Phi2-(2*ThetaIJ));
 return PhiIJ;
}


//-----------------------------//
//--SYMMETRY_MAIN_PROCEDURE ---//
//-----------------------------//
//----------------------------------------------------------
// Symmetry
// ----------------
//
// Mat_ContInfo[k][0]:Orientation
// Mat_ContInfo[k][1]:Potentiel
// Mat_ContInfo[k][2]:LineNumber
// Mat_ContInfo[k][3]:LineLgth
// Value:: -1 :: Empty
//
//----------------------------------------------------------
void LikelihoodSymmetry(float**** Mat_ContInfo,int Nb,float** Mat_Pot,int lgth,int wdth,float** MatLines)
{
 int i,j,k,m,n;
 int LinMid,RowMid;
 int MinLgthImg,MaxLgthImg;
 float PotMoy,LenMoy;
 float DistPts,DistPtsPot;
 float max;
 float NbPairs,NbPairsAcc;
 float AngPot;
 float CrossLines,PotCrossLines;

 //>Cst_&_Variable
 MinLgthImg=MIN(lgth,wdth); 
 MaxLgthImg=(int)(sqrt(CARRE(lgth)+CARRE(wdth))); 
 const float SIGMA=SIGMA_DIST*MinLgthImg; 

 //>Presentation
 printf(" > Likelihood Symmetry [Nb Channel*Resol=%d]...",Nb);
 fflush(stdout);

 //>MemoryAllocation
 float**  MatCum_PotInd=fmatrix_allocate_2d(lgth,wdth);
 float**  MatCum_PotFin=fmatrix_allocate_2d(lgth,wdth);
 float*   VctDist=fmatrix_allocate_1d(2*MaxLgthImg);

 //>Initialization
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Mat_Pot[i][j]=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatCum_PotFin[i][j]=0.0;
 for(k=0;k<(2*MaxLgthImg);k++) VctDist[k]=exp(-(float)k/(SIGMA));

 //===============================================
 //==== Main Loop ================================
 //===============================================
 NbPairsAcc=0.0;
 //>ForEachResol
 //--------------
 for(k=0;k<Nb;k++)
    {
     //Info
     printf("[%d]",k); fflush(stdout);

     //>Normalization[1]::Mat_ContInfo[k][3]:LineLgth
     max=0.0;
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
     if (Mat_ContInfo[k][3][i][j]>max) max=Mat_ContInfo[k][3][i][j]; 

     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     if (Mat_ContInfo[k][3][i][j]>0) Mat_ContInfo[k][3][i][j]/=max;

     //>Normalization[2]::Mat_ContInfo[k][1]:Potential
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
     if (Mat_ContInfo[k][1][i][j]>max) max=Mat_ContInfo[k][1][i][j]; 
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (max) Mat_ContInfo[k][1][i][j]/=max;

     //>InitToZero Pot/Ori [Ind]
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatCum_PotInd[i][j]=0.0;

     //>ForEachPixelPair
     //------------------------------------------------------
     NbPairs=0.0;
     for(i=BORD;i<(lgth-BORD);i+=ACC) for(j=BORD;j<(wdth-BORD);j+=ACC) 
     if (Mat_ContInfo[k][2][i][j]>0)
           {
            //>ForEachPair
            for(m=BORD;m<(lgth-BORD);m+=ACC) for(n=BORD;n<(wdth-BORD);n+=ACC) 
            if (Mat_ContInfo[k][2][m][n]>Mat_ContInfo[k][2][i][j])
	      {
	       DistPts=DistBetwPts(i,j,m,n);

               //>[Constraints]::DIST_MIN::DIST_ANGLE_MIN::DIST_ANLIN_MAX
               if (AngleLine(Mat_ContInfo[k][0][i][j],Mat_ContInfo[k][0][m][n])<DIST_ANLIN_MAX) 
               if ((DistAngle(i,j,m,n,Mat_ContInfo[k][0][i][j])>0)&&(DistPts>DIST_MIN))
	         {
                  //>Inc
		  NbPairs++;
 
                  //>[Constrain-1-]>AngularSymmetryWeighting
                  AngPot=AngularSymmetryWeighting(i,j,m,n,Mat_ContInfo[k][0][i][j],Mat_ContInfo[k][0][m][n]); 

                  //>[Constrain-2-3-]>Potential:Length    
                  PotMoy=0.5*(Mat_ContInfo[k][1][i][j]+Mat_ContInfo[k][1][m][n]);
                  LenMoy=0.5*(Mat_ContInfo[k][3][i][j]+Mat_ContInfo[k][3][m][n]); 

                  //>[Constrain-4-]>Distance
                  LinMid=((i+m)/2);
                  RowMid=((j+n)/2); 
                  DistPtsPot=VctDist[(int)(DistPts)];

                  //>[Constrain-5-]>CrossedLines
                  CrossLines=ComputeNbCrossedLinesInMat(j,i,n,m,MatLines);
                  PotCrossLines=1.0/(1.0+(powf(CrossLines,EXPCROSSLINE)));     

                  //>All-Constraints
                  MatCum_PotInd[LinMid][RowMid]+=PotMoy*LenMoy*DistPtsPot*AngPot*PotCrossLines;     
                 }
              }
	   }//-------------------------------------------------
         
      //>ForEachMapFinalEstimation
      for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatCum_PotFin[i][j]+=MatCum_PotInd[i][j];   

     //>Inc
     NbPairsAcc+=NbPairs;
    }//EndLoop=====================================
 

 //---------------------
 //FinalResult
 //---------------------
 //>Result>Mat_Pot
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Mat_Pot[i][j]=log2(1.0+MatCum_PotFin[i][j]);
 Recal(Mat_Pot,lgth,wdth);

 //>[Constrain-6-]>NotOnContour
 for(k=0;k<Nb;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (Mat_ContInfo[k][2][i][j]>0)
 if (Mat_ContInfo[k][1][i][j]>POT_TEXT_EDGE) Mat_Pot[i][j]=0.0;  
 Recal(Mat_Pot,lgth,wdth); 
 
 //>Info
 printf(" <NbPairs::%.3f 10^6>",NbPairsAcc/1000000);

 //>FreeMemory
 if (MatCum_PotInd) free_fmatrix_2d(MatCum_PotInd);
 if (MatCum_PotFin) free_fmatrix_2d(MatCum_PotFin);
 if (VctDist)       free_fmatrix_1d(VctDist);
}

//-----------//
//---VISU----//
//-----------//
//----------------------------------------------------------
// DisplayPts
//----------------------------------------------------------
void DisplayPts(float*** img,int** TabPts,int NbPts,int lgth,int wdth)
{
 int i,j,k,m,n;
 int row,col;
 const int EP=3;

 //>Loop
 for(k=0;k<NbPts;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   { row=TabPts[k][0];
     col=TabPts[k][1];
     
     for(m=-EP;m<EP;m++) for(n=-EP;n<EP;n++) 
     if (((row+m)<lgth)&&((col+n)<wdth)&&((row+m)>0)&&((col+n)>0))
        { 
          //img[0][row+m][col+n]=(255*k)/NbPts;
          img[0][row+m][col+n]=255; 
          img[1][row+m][col+n]=0;
          img[2][row+m][col+n]=0; } }
}

//----------------------------------------------------------
// AddThreshPotential
//----------------------------------------------------------
void AddThreshPotential(float*** img,float** pot,int lgth,int wdth,float thresh)
{
 int i,j; 
 
 //>loop
 for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
 if (pot[i][j]>thresh) 
    { img[0][i][j]=255;
      img[1][i][j]=0;
      img[2][i][j]=0; 
      img[0][i+1][j]=255;
      img[1][i][j]=0;
      img[2][i][j]=0; 
      img[0][i][j+1]=255;
      img[1][i][j]=0;
      img[2][i][j]=0;
      img[0][i+1][j+1]=255;
      img[1][i][j]=0;
      img[2][i][j]=0;}
}
