//------------------------------------------------------
// module  : FunctionrBISDA.h
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
//   

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>
#include <time.h>

#include "lsd.h"

//------------------------------------------------
// CONSTANTES & DEFINITIONS ----------------------
//------------------------------------------------
#define PI  3.14159
#define GREY_LEVEL 255
#define TROIS 3

#define CARRE(X)  ((X)*(X))
#define SQUARE(X) ((X)*(X))
#define MAX(a,b)   (((a)>(b))?(a):(b))
#define MIN(a,b)   (((a)>(b))?(b):(a))
#define SWAP(x,y) {float t;t=x;x=y;y=t; }

//------------------------------------------------
//FUNCION-BISDA
//------------------------------------------------
//>MatrixAllocation
float*    fmatrix_allocate_1d(int);
float**   fmatrix_allocate_2d(int,int);
float***  fmatrix_allocate_3d(int,int,int);
float**** fmatrix_allocate_4d(int,int,int,int);
int*      imatrix_allocate_1d(int);
int**     imatrix_allocate_2d(int,int);
int***    imatrix_allocate_3d(int,int,int);
unsigned char*    cmatrix_allocate_1d(int);
unsigned char**   cmatrix_allocate_2d(int,int);
unsigned char***  cmatrix_allocate_3d(int,int,int);
void  free_fmatrix_1d(float*);
void  free_fmatrix_2d(float**);
void  free_fmatrix_3d(float***,int);
void  free_fmatrix_4d(float****,int,int);
void  free_imatrix_1d(int*);
void  free_imatrix_2d(int**);
void  free_imatrix_3d(int***,int);
void  free_cmatrix_1d(unsigned char*);
void  free_cmatrix_2d(unsigned char**);
void  free_cmatrix_3d(unsigned char***,int);

//>MatrixGestion 
void  copy_mat(float**,float**,int,int);
void  AverageMat(float***,float**,int,int,int);
void  Recal(float**,int,int);

//>Load/SaveFile
void GetLengthWidth(char*,int*,int*);
void load_image_ppm(char*,float***,int,int);
void SaveImagePgm(char*,char*,float**,int,int);
void SaveImagePpm(char*,char*,float***,int,int);

//>LogPolarMapping
void LogPolarMapping(float**,float**,int,int,int,int,int,int);
void LogPolarMapping(float***,float***,int,int,int,int,int,int);

//>Pre-Traitment
void FillHoleImg(float***,int,int,int);
void FindRegSpacedPts(int,int,float,int,int**,int**);

//>Ending
void AddMatrix(float**,float**,float**,int,int,float);
void GaussianFilter2(float**,float**,int,int);
void GaussianFilter2N(float**,int,int,int);
void NonMaxLocSuppression(float**,int***,float**,int,int,float);
void RemoveLastLineColumn(float**,int,int,int);
void RemoveIsolatedPix(float**,int,int,int);

//------------------------------------------------
//Function-BISDA2
//------------------------------------------------
//>TexturePotential
void GradTexColor(int***,float**,int,int,int,int,int);
void AddGradImg(int***,float**,float**,int,int,float);

//>SymmetryGestion
float Angle(int,int,int,int);
float AngleLine(float,float);
float DistBetwPts(int,int,int,int);
float DistAngle(int,int,int,int,float);

//>SymmetryMainProcedure
void LikelihoodSymmetry(float****,int,float**,int,int,float**);

//>Visu
void DisplayPts(float***,int**,int,int,int);
void AddThreshPotential(float***,float**,int,int,float);

