//---------------------------------------------------
// module  : f_BISDA.cc                       
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "BISDA.h"

//------------------------------------------------
// METHODES DE LA CLASSE KMEANCONSTRAIN  ---------
//------------------------------------------------
//----------------------------------------------------------
// Constructeur de la classe BISDA
//----------------------------------------------------------
BISDA::BISDA(float*** img,int lgth,int wdth)           
 {
  int i,j,k;

  //Initialisation
  length=lgth;
  width=wdth;

  //Allocation Memoire Matrice 
  mat_img=imatrix_allocate_3d(TROIS,length,width);
  mat_imgF=fmatrix_allocate_3d(TROIS,length,width);
  mat_sym=fmatrix_allocate_2d(length,width);

  //Initialisation[Img::mat_img|mat_imgF]
  for(k=0;k<TROIS;k++) for(i=0;i<length;i++) for(j=0;j<width;j++) 
    { mat_imgF[k][i][j]=img[k][i][j];
      mat_img[k][i][j]=(int)img[k][i][j]; }
 }

//----------------------------------------------------------
// Destructeur de la classe BISDA
//----------------------------------------------------------
BISDA::~BISDA()
{ 
  //Libere Memoire Matrice 
  if (mat_img)   free_imatrix_3d(mat_img,TROIS); 
  if (mat_imgF)  free_fmatrix_3d(mat_imgF,TROIS); 
  if (mat_sym)   free_fmatrix_2d(mat_sym); 
}

//------------------------------------------------
// METHODES DE LA CLASSE BISDA -------------------
//------------------------------------------------
//----------------------------------------------------------
// DetecSymmetry
//----------------------------------------------------------
void BISDA::DetecSymmetry()
{
 int i,j,k,l;
 char MyBuf[100];

 //float Par1=ParM;    
  
 //>Presentation
 printf("\n =========");
 printf("\n   BISDA");
 printf("\n =========");
 printf("\n  Size :: [lgth=%d  | wdth=%d]",length,width);
 printf("\n  Parametres :: [ParM=%.2f]\n",ParM);
 fflush(stdout);

 //>MemoryAllocation  
 int**     TabPts=imatrix_allocate_2d(NB_DEFOR,2);      
 int**     TabPtsInc=imatrix_allocate_2d(NB_DEFOR,2);  
 float**** ImgTab=fmatrix_allocate_4d(NB_DEFOR,TROIS,length,width);
 float***  ImgSymTab=fmatrix_allocate_3d(NB_DEFOR,length,width);
 float**   mat_tmp0=fmatrix_allocate_2d(length,width);
 float**   mat_tmp1=fmatrix_allocate_2d(length,width);
 float**   mat_tmp2=fmatrix_allocate_2d(length,width);
 float**   mat_tmp3=fmatrix_allocate_2d(length,width);
 float**   mat_tmp4=fmatrix_allocate_2d(length,width);

 //>Init
 for(l=0;l<NB_DEFOR;l++) for(k=0;k<TROIS;k++) for(i=0;i<length;i++) for(j=0;j<width;j++)
 ImgTab[l][k][i][j]=0.0; 

 for(l=0;l<NB_DEFOR;l++) for(i=0;i<length;i++) for(j=0;j<width;j++)
 ImgSymTab[l][i][j]=0.0; 

 for(i=0;i<length;i++) for(j=0;j<width;j++)
    {  mat_tmp0[i][j]=0.0;
       mat_tmp1[i][j]=0.0;
       mat_tmp2[i][j]=0.0;
       mat_tmp3[i][j]=0.0;
       mat_tmp4[i][j]=0.0; }

 //================================================================
 //[1]>SymetrieOnPolarDeformations
 //================================================================
 //>SamplingPos   
 FindRegSpacedPts(length,width,PROP_WND,NB_DEFOR,TabPts,TabPtsInc);     
 for(l=0;l<NB_DEFOR;l++) printf(" [%d::%d]",TabPts[l][0],TabPts[l][1]);

 //>LogPolar_Deformations
 for(l=0;l<NB_DEFOR;l++) 
    { printf("\n <<[%d]>>",l); fflush(stdout);
      LogPolarMapping(mat_imgF,ImgTab[l],length,width,TabPtsInc[l][0],TabPtsInc[l][1],0,1);            
      FillHoleImg(ImgTab[l],length,width,1);
      FuncComputeSym(ImgTab[l],mat_tmp0,length,width);  
      LogPolarMapping(mat_tmp0,ImgSymTab[l],length,width,TabPtsInc[l][0],TabPtsInc[l][1],1,1);        
    }   
 //=End===============================================================

 //===============================================
 //[2]>Averaging+ImgWithoutDeformation
 //===============================================
 //Averaging[LogPol]>mat_tmp1
 printf("\n > Moyennage sur [%d] Cartes de Potentielle",NB_DEFOR);
 AverageMat(ImgSymTab,mat_tmp1,length,width,NB_DEFOR); 

 //Sym[ImgCart]>mat_tmp2
 FuncComputeSym(mat_imgF,mat_tmp2,length,width);
 printf("\n > Ajout Sym. sur Img Cartesienne [prop=%.2f]",ADDIMGCART);
 AddMatrix(mat_tmp1,mat_tmp2,mat_tmp3,length,width,ADDIMGCART);
 Recal(mat_tmp3,length,width);

 //===============================================
 //[3]>NonMaxLocSup/Cleaning
 //=============================================== 
 GaussianFilter2N(mat_tmp3,length,width,NBGAUSSFILTPOT);
 NonMaxLocSuppression(mat_tmp3,mat_img,mat_tmp4,length,width,3); 
 RemoveLastLineColumn(mat_tmp4,length,width,REMOVELASTLINE); 
 Recal(mat_tmp4,length,width);
 copy_mat(mat_tmp4,mat_sym,length,width); 

 //>Save
 i=strlen(Name_Img);
 strncpy(MyBuf,Name_Img,i-4);
 Recal(mat_sym,length,width);
 SaveImagePgm(MyBuf,(char*)"",mat_sym,length,width);

 //>FreeMemory
 if (TabPts)    free_imatrix_2d(TabPts);
 if (TabPtsInc) free_imatrix_2d(TabPtsInc);
 if (ImgTab)    free_fmatrix_4d(ImgTab,NB_DEFOR,3);
 if (ImgSymTab) free_fmatrix_3d(ImgSymTab,NB_DEFOR);
 if (mat_tmp0)  free_fmatrix_2d(mat_tmp0);
 if (mat_tmp1)  free_fmatrix_2d(mat_tmp1);
 if (mat_tmp2)  free_fmatrix_2d(mat_tmp2);
 if (mat_tmp3)  free_fmatrix_2d(mat_tmp3);
 if (mat_tmp4)  free_fmatrix_2d(mat_tmp4);
}

//----------------------------------------------------------
// FuncComputeSym
//----------------------------------------------------------
void BISDA::FuncComputeSym(float*** ImgInF,float** Mat_LikSymPot1,int lgth,int wdth)
{
 int i,j,k,l;
 
 //>AllocationMemoryUsed
 float**** Mat_ContInfo=fmatrix_allocate_4d(NB_RESOL*3,4,lgth,wdth);  
 float**   Mat_Cnt1=fmatrix_allocate_2d(lgth,wdth);
 float**   Mat_Cnt2=fmatrix_allocate_2d(lgth,wdth);
 float**   Mat_SoftCont1=fmatrix_allocate_2d(lgth,wdth);
 float**   Mat_SoftCont2=fmatrix_allocate_2d(lgth,wdth);
 float**   Mat_LikSymOri=fmatrix_allocate_2d(lgth,wdth);
 int***    ImgIn=imatrix_allocate_3d(TROIS,lgth,wdth);

 //>MatrixInitialisation
 for(k=0;k<TROIS;k++) 
 for(i=0;i<length;i++) for(j=0;j<width;j++) ImgIn[k][i][j]=(int)ImgInF[k][i][j];

 for(i=0;i<length;i++) for(j=0;j<width;j++) Mat_LikSymPot1[i][j]=0.0;

 for(k=0;k<NB_RESOL;k++) for(l=0;l<4;l++) for(i=0;i<length;i++) for(j=0;j<width;j++)
 Mat_ContInfo[k][l][i][j]=0.0;

 for(i=0;i<length;i++) for(j=0;j<width;j++)
   { Mat_Cnt1[i][j]=0.0;
     Mat_Cnt2[i][j]=0.0;
     Mat_SoftCont1[i][j]=0.0;
     Mat_SoftCont2[i][j]=0.0;
     Mat_LikSymOri[i][j]=0.0; }

 //===============
 //ALGO ==========================================
 //===============
 //>PotentialTexture
 GradTexColor(ImgIn,Mat_SoftCont2,lgth,wdth,3,5,7);
 AddGradImg(ImgIn,Mat_SoftCont2,Mat_SoftCont1,lgth,wdth,1.0);

 //>LineSegmentDetector+FilterPotentialTexture
 My_LSD_Sym(ImgIn,lgth,wdth,Mat_ContInfo,Mat_SoftCont1,T_EPS,RES_MIN,RES_MAX,NB_LINES,NB_RESOL,Mat_Cnt2);
  
 //>SymetryLikelihoodPotential
 LikelihoodSymmetry(Mat_ContInfo,NB_MAPS,Mat_LikSymPot1,lgth,wdth,Mat_Cnt2);     
 Recal(Mat_LikSymPot1,lgth,wdth); 
 //==END_ALGO======================================

 //>Libere Memoire Matrice  
 if (Mat_ContInfo)    free_fmatrix_4d(Mat_ContInfo,NB_RESOL,4);   
 if (Mat_SoftCont1)   free_fmatrix_2d(Mat_SoftCont1);
 if (Mat_SoftCont2)   free_fmatrix_2d(Mat_SoftCont2);
 if (Mat_Cnt1)        free_fmatrix_2d(Mat_Cnt1);
 if (Mat_Cnt2)        free_fmatrix_2d(Mat_Cnt2);
 if (Mat_LikSymOri)   free_fmatrix_2d(Mat_LikSymOri);
 if (ImgIn)           free_imatrix_3d(ImgIn,TROIS);  
}




 
